<?php

class controller_plugin_unicomments_form_plugin extends plugin {

	protected function add_comment($url, $name, $email, $phone, $text) {
		$row = $this->dbh->row("SELECT seq FROM sqlite_sequence WHERE name='unicomments'");
		if ($this->dbh->exec("
			INSERT INTO unicomments (url, name, email, phone, date_add, date_answer, text, answer)
			VALUES ('$url', '$name', '$email', '$phone', '".time()."', '0', '$text', '')
		")) {
			return $row['seq']+1;
		} else {
			return false;
		}
	}



	protected function get_unanswered_count() {
		$row = $this->dbh->row("SELECT COUNT(*) AS num FROM unicomments WHERE date_answer='0'");
		return $row['num'];
	}




	protected function get_unicomments_component_url() {
		$row = $this->dbh->row("SELECT url FROM main WHERE component='unicomments'");
		return '/'.$row['url'];
	}




	protected function email($mailTo, $mailFrom, $nameFrom, $subject, $text, $charset='utf-8') {
		$headers ="Date: ".date("D, j M Y G:i:s")." +0700\r\n"; 
		$headers.="From: =?".$charset."?Q?".str_replace("+","_",str_replace("%","=",urlencode($nameFrom)))."?= <".$mailFrom.">\r\n";
		$headers.="X-Mailer: The Bat! (v3.99.3) Professional\r\n"; 
		$headers.="X-Priority: 3 (Normal)\r\n";
		$headers.="Message-ID: <172562218.".date("YmjHis")."@mail.ru>\r\n";
		$headers.="MIME-Version: 1.0\r\n";
		$headers.="Content-Type: text/html; charset=".$charset."\r\n";
		return mail($mailTo,$subject,$text,$headers);
	}






	public function action_index($plugin) {
		$params = unserialize($plugin['params']);
		$errors = Array();

		$this->data['name'] = $name = isset($_POST['name']) ? trim($_POST['name']) : '';
		$this->data['email'] = $email = isset($_POST['email']) ? trim($_POST['email']) : '';
		$this->data['phone'] = $phone = isset($_POST['phone']) ? trim($_POST['phone']) : '';
		$this->data['text'] = $text = isset($_POST['text']) ? $_POST['text'] : '';

		if (isset($_SESSION['unicomments_form_success'])) {
			$this->data['show_success'] = true;
			unset($_SESSION['unicomments_form_success']);
		} else {
			$this->data['show_success'] = false;
		}


		if (isset($_POST['submit'])) {

			if ($params['name_status'] == 'required') {
				if ($name == '') $errors[] = 'Укажите ваше имя.';
			}
			if ($params['email_status'] == 'required') {
				if ($email == '') $errors[] = 'Укажите ваш E-mail.';
				if (!mb_ereg_match('^[a-z0-9\._]+@[a-z0-9\._]+\.[a-z0-9]+$', $email))
				$errors[] = 'E-mail имеет неверный формат.';
			}
			if ($params['phone_status'] == 'required') {
				if ($phone == '') $errors[] = 'Укажите ваш телефон.';
				$phone = preg_replace('/\D/', '', $phone);
				if ($phone == '') $errors[] = 'Телефон имеет неверный формат. Вводите только цифры';
			}
			if ($text == '') $errors[] = 'Текст комментария не заполнен.';

			$captcha_id = isset($_POST['CAPTCHA_id']) ? $_POST['CAPTCHA_id'] : '';
			$captcha = isset($_POST['CAPTCHA']) ? $_POST['CAPTCHA'] : '';
			if ($params['captcha_type'] == 'text') $captcha = mb_convert_case($captcha, MB_CASE_UPPER, 'utf-8');
			if ($params['captcha_type'] != 'none' &&
				isset($_SESSION['CAPTCHA'.$captcha_id]) &&
				$_SESSION['CAPTCHA'.$captcha_id] != md5($captcha)) 
			{
				if ($params['captcha_type'] == 'text') $errors[] = 'Неправильно указан ответ на контрольный вопрос.';
				if ($params['captcha_type'] == 'image') $errors[] = 'Неправильно введены буквы с картинки (нужны только буквы, а не цифры).';
			}

			if (count($errors) == 0) {
				$newid = $this->add_comment(
					$_POST['url'],
					htmlspecialchars($name),
					htmlspecialchars($email),
					$phone,
					htmlspecialchars($text)
				);
				if ($newid === false) $errors[] = 'Ошибка соединения с базой комментариев. Попробуйте отправить еще раз.';
			}

			if (count($errors) == 0) {
				if ($params['admin_emails'] != '') {
					$expires = time()+3600*24*7;
					$key1 = md5('cf98'.$expires.'/command=0/id='.$newid).'a0de'.dechex($expires);
					$key2 = md5('cf98'.$expires.'/command=1').'a0de'.dechex($expires);
					$email_html = '
					<h1>На вашем сайте оставили комментарий</h1>
					<p><strong>Пользователь:</strong> '.$name.', email: '.$email.', phone: '.$phone.'</p>
					<p><strong>Дата: </strong>'.date('d.m.Y H:i:s').'</p>
					<p><strong>На странице: </strong>'.SITE_URL.$_POST['url'].'</p>
					<p><strong>Текст:</strong><br>'.$text.'</p>
					<br>
					<a href="'.SITE_URL.$this->get_unicomments_component_url().'/admin/key='.$key1.'/command=0/id='.$newid.'">Ответить / редактировать</a><br>
					<a href="'.SITE_URL.$this->get_unicomments_component_url().'/admin/key='.$key2.'/command=1">Смотреть все неотвеченные ('.$this->get_unanswered_count().')</a><br>
					<p>Внимание! Предоставленные ссылки действуют до '.date('d.m.Y H:i:s', $expires).'.<br>
					Никогда не публикуйте эти ссылки!</p> 
					';

					$this->email(
						$params['admin_emails'],
						$params['admin_emails'],
						'UNICOMMENTS',
						'Добавлен комментарий на сайте '.SITE_URL,
						$email_html
					);
				}

				//т.к. плагин загружается в последнюю очередь, нужно обновить страницу чтобы добавленный комментарий стал виден
				$_SESSION['unicomments_form_success'] = true;
				$this->redirect(SITE_URL.$this->url['request_uri']);
			}
		}


		$this->data['errors'] = $errors;
		$this->data['params'] = $params;
		if (!isset($_SESSION['next_captcha_id']) || $_SESSION['next_captcha_id'] > 64) $_SESSION['next_captcha_id'] = 0;
		$this->data['captcha_id'] = $_SESSION['next_captcha_id']++;
		$this->data['plugin_id'] = $plugin['id'];
		$this->data['access_lvl'] = isset($_SESSION['access']) ? $_SESSION['access'] : 0;
		$this->data['url'] = preg_replace('/\/[^\/\s]+=[^\/\s]+/', '', $this->url['request_uri']);

		$this->page['head'] = $this->add_css_file(SITE_URL.'/modules/plugins/unicomments_form_plugin/views/style.css');
		$this->page['html'] = $this->load_view();
		return $this->page;
	}





	public function action_settings($plugin) {
		$params = unserialize($plugin['params']);

		foreach($params as $key=>$value) if (isset($_POST[$key])) $params[$key] = $_POST[$key];
		
		if (isset($_POST['edit_settings'])) {
			return Array('params' => serialize($params));
		} else {
			$this->data['params'] = $params;
			$this->page['html'] = $this->load_view('settings');
			return $this->page;
		}
	}




	public function action_activate() {
		$params = Array(
			'admin_emails'=> 'admin@thisssite.com',
			'form_header' => 'Добавить комментарий',
			'form_success'=> 'Ваш комментарий добавлен.',
			'name_status' => 'required',
			'name_label'  => 'Ф.И.О.:',
			'email_status'=> 'required',
			'email_label' => 'e-mail:',
			'phone_status'=> 'required',
			'phone_label' => 'Телефон:',
			'text_label'  => 'Комментарий:',
			'captcha_type'=> 'text'
		);

		foreach($params as $key=>$value) if (isset($_POST[$key])) $params[$key] = $_POST[$key];
		$this->data['params'] = $params;

		if (isset($_POST['activate'])) {
			return Array('params' => serialize($params), 'html' => $this->load_view('settings'));
		} else {
			$this->page['html'] = $this->load_view('settings');
			return $this->page;
		}
	}

}