<div id="content">
	<h1>Комментарии<?=$unanswered ? ' без ответа' : ''?> - <?=$comments_count?></h1>
	<?php if (count($comments) > 0) { 
		if (!$unanswered) echo '<a href="'.SITE_URL.'/admin/unicomments/unanswered">Показать без ответа</a>';
		else echo '<a href="'.SITE_URL.'/admin/unicomments">Показать все</a>'; ?>
		<br><br><table class="main">
			<tr>
				<th>ID</th>
				<th>URL</th>
				<th>Имя</th>
				<th>Добавлен</th>
				<th>Текст</th>
				<th>Текст ответа</th>
				<th>Действия</th>
			</tr>
	<?php foreach ($comments as $comment) { ?>
			<tr id="<?=$comment['id']?>">
				<td><?=$comment['id']?></td>
				<td title="<?=$comment['url']?>">
					<?=(strlen($comment['url']) > 24) ? substr($comment['url'], 0, 24).'...' : $comment['url']?>
				</td>
				<td><?=$comment['name']?></td>
				<td><?=date('d.m.Y H:i:s', $comment['date_add'])?></td>
				<td title="<?=$comment['text']?>">
					<?=(strlen($comment['text']) > 64) ? substr($comment['text'], 0, 64).'...' : $comment['text']?>
				</td>
				<td title="<?=$comment['answer']?>">
					<?=(strlen($comment['answer']) > 64) ? substr($comment['answer'], 0, 64).'...' : $comment['answer']?>
				</td>
				<td>
					<a href="<?=SITE_URL?>/admin/unicomments/remove/id=<?=$comment['id']?>">Удалить</a>
					<a href="<?=SITE_URL?>/admin/unicomments/edit/id=<?=$comment['id']?>">Изменить</a>
				</td>
			</tr>
	<?php } ?>
		</table>
		<ul class="pages">
			<?php
				//стрелка влево
				if ($current_page > 0) {
					echo '<li><a href="'.SITE_URL.'/admin/unicomments/page='.($current_page-1).'">◄</a></li>';
				} else {
					echo '<li class="passive">◄</li>';
				}
				//если много страниц
				if ($pages_amount > 15) {
					//если далеко от начала
					if ($current_page > 5) {
						$prefix = '<li><a href="'.SITE_URL.'/admin/unicomments/page=0">1</a></li><li class="passive">...</li>';
						$start = $current_page - 5;
					} else {
						$prefix = '';
						$start = 0;
					}
					//если далеко от конца
					if ($current_page < $pages_amount - 6) {
						$postfix = '<li class="passive">...</li><li><a href="'.SITE_URL.'/admin/unicomments/page='.($pages_amount - 1).'">'.$pages_amount.'</a></li>';
					} else {
						$postfix = '';
						$start = $pages_amount - 11;
					}
					echo $prefix;
					for ($i=$start; $i<$start+11; $i++) if ($i == $current_page) {
						echo '<li class="passive current">'.($i+1).'</li>';
					} else {
						echo '<li><a href="'.SITE_URL.'/admin/unicomments/page='.$i.'">'.($i+1).'</a></li>';
					}
					echo $postfix;
				//если мало страниц
				} else {
					for ($i=0; $i<$pages_amount; $i++) if ($i == $current_page) {
						echo '<li class="passive current">'.($i+1).'</li>';
					} else {
						echo '<li><a href="'.SITE_URL.'/admin/unicomments/page='.$i.'">'.($i+1).'</a></li>';
					}
				}
				//стрелка вправо
				if ($current_page < $pages_amount-1) {
					echo '<li><a href="'.SITE_URL.'/admin/unicomments/page='.($current_page+1).'">►</a></li>';
				} else {
					echo '<li class="passive">►</li>';
				}		
			?>
		</ul>
	<?php } else { ?>
		<br><p>Пока нет ни одного комментария</p>
	<?php } ?>
</div>